
#include <allegro.h>
#include <iostream>
#include <vector>
#include <math.h>
#include <list>
#include <set>
#include <fstream>
#include <algorithm>
#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif
#include "random.hpp"
#include "map.txt"

struct Pos{
	float x;
	float y;
};

Pos player;
Pos child;
using namespace std;
const float PI = 3.1415926535;
BITMAP* buffer;
BITMAP* l2sprites;
BITMAP* title;
BITMAP* bg[3];
BITMAP* icons;
BITMAP* child1;
BITMAP* nanny1;
BITMAP* trolley3;
FONT* f;


BITMAP* scenes[4][20];
const int imagecount[4]={2,1,1,1 };

int endtimer=0;

/*
 
map

 101
 101
 101
 111
 
 
 
 */
const int FRAMERATE=30;

char scoretxt[100];
int score=0;
int timeleft=60*FRAMERATE;
char timetxt[100];


const int SCREEN_WIDTH=640;
const int SCREEN_HEIGHT=480;

bool upheld=false;
bool downheld=false;
bool spaceheld=true;
bool leftheld=true;
bool rightheld=true;
int talkcount;
bool talking;
int curline;

const int map_w=10;
const int map_h=7;
const int TILE_SIZE=100;

int brightness;
char itemcounttext[30];

const int TILE_WIDTH=11;
const int TILE_HEIGHT=14;

const int endx=55; const int endy=8;


const int COL_MAX=50;
Pos collectables[COL_MAX];
int colcount;
int colmax;

int gtime;

int magenta;
int red;
int pink;
int lightred;
int black;
int white;
int green;
int lightgreen;
int orange;
int purp0;
int purp1;
int purp2;
int grey;
int lightgrey;
int blue;
int yellow;
int bgcol;

void cutbars()
{
	rectfill(buffer, 0, 0, SCREEN_WIDTH, 200, black);
	rectfill(buffer, 0, SCREEN_HEIGHT-200, SCREEN_WIDTH, SCREEN_HEIGHT, black);
}

int itemcount=0;


bool spacepressed;


bool quit=false;


int algdone=false;

char leveltitle[200];



int levelseed;
const int MARGIN=10;
const int TRIANGLE_SIZE = 50;
const int ICON_RADIUS = 10;
const int FONT_HEIGHT=8;
int bltime;
int endmenutimer;
bool endmode;

bool gameover;
uint musictimer;

bool dragmode;
uint curnote;

uint melody_length=10;
int level_code;


Pos pos;
Pos vel;
int control;


const int People_Count=10;
Pos peeps[People_Count];
Pos peepsvel[People_Count];

bool deadly[46][61];

Pos target;
bool inbase[2];

Pos base[2];

const int CIRCLECOUNT=20;

Pos circles[CIRCLECOUNT];
Pos circelvels[CIRCLECOUNT];

//used for targetting numerical enemies

#include "sound.hpp"
#include "timer.hpp"

const int ts=13;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool escpressed;
bool apressed;

bool collided;

int leveltimer;

int levelgoal;



bool stoppedfather;
bool upblock;



const int T1=35;
const int T2=25;

int killtimer=0;

Pos oldmouse;
Pos newmouse;
int scoremodifier;

const Pos anchor={SCREEN_WIDTH/2,SCREEN_HEIGHT/2};
Pos p1,p2;
Pos f1,f2;
Pos v1,v2;

inline float len(Pos a, Pos b)
{
	return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}
inline float len(Pos a)
{
	return sqrt((a.x)*(a.x)+(a.y)*(a.y));
}

template<int levelno>
class LevelLoop;


const float TOP=202;
const float BOTTOM=320;
const float LEFT=208;
const float RIGHT=433;
int levelendtimer=0;
const float v=3.0f;

template<>
class LevelLoop<0>
	{
	public:
		static void initialize()
		{

			quit=false;
			finishedtitle=false;
			spaceheld=true;
			escpressed=true;
			leftheld=true;
			rightheld=true;
			talking=false;
			player.x=LEFT+((RIGHT-LEFT)*2)/3;
			player.y=TOP+(BOTTOM-TOP)/2;
			child.x=LEFT+((RIGHT-LEFT))/3;
			child.y=TOP+(BOTTOM-TOP)/2;
			levelendtimer=0;
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			
			if (key[KEY_ESC])
			{
				if (!escpressed)
				{
					quit=true;
				}
			}
			else escpressed=false;
			
			if (endtimer>0)
			{
				endtimer--;
				if (endtimer==0)
				{
					finishedtitle=true;
				}
				return;
			}
			
			if (key[KEY_UP])
			{
				player.y-=v;
			}
			if (key[KEY_DOWN])
			{
				player.y+=v;
			}
			if (key[KEY_LEFT])
			{
				player.x-=v;
			}
			if (key[KEY_RIGHT])
			{
				player.x+=v;
			}
			
			if (player.x<LEFT)
				player.x=LEFT;
			if (player.x>RIGHT)
				player.x=RIGHT;
			if (player.y<TOP)
				player.y=TOP;
			if (player.y>BOTTOM)
				player.y=BOTTOM;
			
			Pos dir;
			dir.x=child.x-player.x;
			dir.y=child.y-player.y;
			float l=len(dir);
			if (l!=0)
			{
				dir.x/=l;
				dir.y/=l;
			}
			
			child.x+=dir.x*v;
			child.y+=dir.y*v;
			if (child.x<LEFT)
				child.x=LEFT;
			if (child.x>RIGHT)
				child.x=RIGHT;
			if (child.y<TOP)
				child.y=TOP;
			if (child.y>BOTTOM)
				child.y=BOTTOM;
			
			if (child.y==BOTTOM||child.y==TOP)
			{
				child.x++;
			}
			if (child.x==LEFT||child.x==TOP)
			{
				child.y++;
			}
			
			if (child.x<LEFT)
				child.x=LEFT;
			if (child.x>RIGHT)
				child.x=RIGHT;
			if (child.y<TOP)
				child.y=TOP;
			if (child.y>BOTTOM)
				child.y=BOTTOM;
			
			if (child.x==RIGHT&&child.y==BOTTOM)
			{
				endtimer=80;
				playsample(0);
			}
			
		}
		static void draw()
		{
			blit(bg[0], buffer, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
			masked_blit(child1,buffer,0,0,child.x-16,child.y-32, 32,32);
			masked_blit(nanny1,buffer,0,0,player.x-16,player.y-32, 32,32);
		}
	};

int states[3];
int correctstreak;
int correct=false;



template<>
class LevelLoop<1>
{
public:
	static void initialize()
	{
		for (int i=0;i<3;i++)
		{
			states[i]=0;//0 nothing, 1 good, -1 bad
		}
		leveltimer=0;
		quit=false;
		finishedtitle=false;
		spaceheld=true;
		escpressed=true;
		leftheld=true;
		rightheld=true;
		correctstreak=0;
		talking=false;
	}
	static bool quitcondition()
	{
		return quit||finishedtitle;
	}
	static void logic()
	{
		
		if (key[KEY_ESC])
		{
			if (!escpressed)
			{
				quit=true;
			}
		}
		else escpressed=false;
		leveltimer++;
		
		if (leveltimer==0)
		{
			states[0]=-1;
			states[1]=0;
			states[2]=0;
		}
		else if (leveltimer==30)
		{
			states[0]=0;
			states[1]=0;
			states[2]=0;			
		}
		else if (leveltimer==60)
		{
			states[0]=-1;
			states[1]=0;
			states[2]=0;			
		}
		else if (leveltimer==90)
		{
			correct=!correct;
			states[0]=-1;
			states[1]=(2*correct)-1;
			states[2]=0;			
		}
		else if (leveltimer==120)
		{
			leveltimer--;
			if (key[KEY_UP])
			{
				if (!correct)
				{
					playsample(0);
					correctstreak++;
				}
				else
				{
					playsample(1);					
					correctstreak=0;
				}
				
				leveltimer++;
				states[2]=1;
			}
			else if (key[KEY_DOWN])
			{
				if (correct)
				{
					playsample(0);
					correctstreak++;
				}
				else
				{
					playsample(1);					
					correctstreak=0;
				}
				
				leveltimer++;				
				states[2]=-1;
			}
		}
		else if (leveltimer==150)
		{
			if (correctstreak==5)
			{
				leveltimer++;
			}
			else
			{
				leveltimer=-1;
			}
		}
		else if (leveltimer==180)
		{
			finishedtitle=true;
		}
		
		
		
	}
	static void draw()
	{
		blit(bg[1], buffer, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
		sprintf(scoretxt,"%d/5",correctstreak);
		textout_ex(buffer,f,scoretxt,10,10,makecol(170,211,58),makecol(211,140,58));
		for (int i=0;i<3;i++)
		{
			switch (states[i])
			{
				case -1:
					masked_blit(l2sprites, buffer,128*i , 0, 115+i*133, 153, 128, 128);
					break;
				case 0:
					masked_blit(l2sprites, buffer,128*i , 128,  115+i*133, 153, 128, 128);
					break;
				case 1:
					masked_blit(l2sprites, buffer,128*i , 256,  115+i*133, 153, 128, 128);
					break;
					
			}
		}
	}
};

int xpos;

template<>
class LevelLoop<2>
{
public:
	static void initialize()
	{
		
		quit=false;
		finishedtitle=false;
		spaceheld=true;
		escpressed=true;
		leftheld=true;
		rightheld=true;
		talking=false;
		xpos=-128;
	}
	static bool quitcondition()
	{
		return quit||finishedtitle;
	}
	static void logic()
	{
		
		if (key[KEY_ESC])
		{
			if (!escpressed)
			{
				quit=true;
			}
		}
		else escpressed=false;
		
		if (key[KEY_RIGHT])
		{
			xpos+=v;
		}
		
		if (xpos>SCREEN_WIDTH+10)
		{
			finishedtitle=true;
		}
	}
	static void draw()
	{
		clear_to_color(buffer, black);
		blit(bg[2], buffer, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
		masked_blit(trolley3, buffer, 0, 0, xpos, 279, 190, 122);
	}
};

template<int i>
class BlackLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			bltime=0;
			finishedtitle=false;
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			bltime++;
			if (bltime>i*FRAMERATE)
			{
				finishedtitle=true;
			}


			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

		}
		static void draw()
		{
			clear_to_color(buffer, bgcol);
		}
	};


template<class T> void loop();



int storyprogress;
bool finishedstory;
int pauseafter;



class IntroLoop
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}

		static void draw()
		{
			for (int i=0;i<SCREEN_HEIGHT;i++)
				hline(buffer, 0, i, SCREEN_WIDTH-1, (i%2==0)?makecol(58,178,211) :makecol(157,79,108));
			textout_centre_ex(buffer, f, "cavanagh, terry & lavelle, stephen present", SCREEN_WIDTH/2, SCREEN_HEIGHT/2-40,makecol(170,211,58),makecol(211,140,58));

		}
	};


int cutscenepos;
template<int scene>
class CutsceneLoop
	{
	public:
		static void initialize()
		{
			cutscenepos=0;
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}
		
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		
		static void logic()
		{
			if (key[KEY_SPACE]||key[KEY_ESC])
			{
				if (!spacepressed)
				{
					cutscenepos++;
					if (cutscenepos>=imagecount[scene])
					{
						finishedtitle=true;
						cutscenepos--;
					}

				}
			}
			spacepressed=key[KEY_SPACE]||key[KEY_ESC];
		}
		
		static void draw()
		{
			blit(scenes[scene][cutscenepos], buffer, 0, 0, 0, 0, 640, 480);
		}
	};


class IntroDialogue
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
			quit=false;

		}
		
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		
		static void logic()
		{
			titletimer++;
			
			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}
		
		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "increpare presents", 160, 4*10,white, -1);
			
		}
	};



class TitleLoop
	{
	public:
		static bool begin;
		static unsigned int selected;
	public:
		static void initialize()
		{
			levelseed=1;
			spacepressed=true;
			endmode=false;
			endmenutimer=0;
			quit=false;
			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;
			leftheld=true;
			rightheld=true;
			talking=false;
			talkcount=0;
		}

		static void logic()
		{

			if (endmenutimer>0)
			{
				endmenutimer--;


				return;
			}

			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

			
			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected+1)%2;
					upheld=true;
					playsample(0);
				}
			}
			else
				upheld=false;
			
			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%2;
					downheld=true;
					playsample(0);
				}
			}
			else
				downheld=false;
			
			
			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					playsample(0);
					if (selected==0)
					{
						begin=true;
						endmenutimer=40;
					}
					else
					{
						quit=true;
						endmenutimer=40;
					}
				}
			}
			else
				spaceheld=false;
			
		}

		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}

		static void draw()
		{			
			for (int i=0;i<SCREEN_HEIGHT;i++)
				hline(buffer, 0, i, SCREEN_WIDTH-1, (i%2==0)?makecol(58,178,211) :makecol(157,79,108));

			masked_blit(title, buffer,0,0,0,0,SCREEN_WIDTH,SCREEN_HEIGHT);
			if ( (endmenutimer>0 && endmenutimer<10))
			{
				return;
			}

			if (selected==0)
			{
				if (endmenutimer%2==0)
				textout_ex(buffer,f," START ",260+50,420,bgcol,makecol(255,255,255));
				textout_ex(buffer,f," Exit ",260+50,440,makecol(170,211,58),makecol(211,140,58));
			}
			else
			{
				textout_ex(buffer,f," Start ",260+50,420,makecol(170,211,58),makecol(211,140,58));

				if (endmenutimer%2==0)
				textout_ex(buffer,f," EXIT ",260+50,440,bgcol,makecol(255,255,255));
			}

		}

	};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;

template<class T>
void loop()
{

	clear_to_color(buffer, bgcol);

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			//			if (key[KEY_ESC])
			//				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

        blit(buffer, screen, 0, 0, 0,0,SCREEN_WIDTH, SCREEN_HEIGHT);

	}
}



void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
	#endif

	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(FRAMERATE));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, SCREEN_WIDTH,SCREEN_HEIGHT, 0, 0) ;

	red=makecol(255,0,0);
	lightred=makecol(255,200,200);
	pink=makecol(255,192,203);
	magenta=makecol(255,0,255);
	black=makecol(0,0,0);
	white=makecol(255,255,255);
	blue=makecol(0,0,255);
	bgcol=makecol(0,0,0);
	yellow=makecol(255,255,0);
	green=makecol(0,255,0);
	lightgreen=makecol(200,255,200);
	grey=makecol(100,100,100);
	lightgrey=makecol(200,200,200);
	orange=makecol(253,183,58);
	purp0=makecol(107,30,98);
	purp1=makecol(199,40,162);
	purp2=makecol(255,220,255);

	//load save data


	//init the buffer
	buffer=create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);
	bg[0]=load_bitmap("bmp/bg0.bmp",NULL);
	bg[1]=load_bitmap("bmp/bg1.bmp",NULL);
	l2sprites=load_bitmap("bmp/l2sprites.bmp",NULL);
	bg[2]=load_bitmap("bmp/bg2.bmp",NULL);
	child1=load_bitmap("bmp/img1.bmp",NULL);
	nanny1=load_bitmap("bmp/img2.bmp",NULL);
	trolley3=load_bitmap("bmp/trolley.bmp",NULL);
	icons=load_bitmap("bmp/icons2.bmp",NULL);
	title=load_bitmap("bmp/title.bmp",NULL);
	f=load_bitmap_font("bmp/font.pcx",NULL,NULL);
	if (f==0)
	{
		exit(0);
	}
	
	
	for (int i=0;i<4;i++)
	{
		for (int j=0;j<imagecount[i];j++)
		{
			char blah[20];
			sprintf(blah, "bmp/%d-%d.bmp",i,j);
			scenes[i][j]=load_bitmap(blah, NULL);
		}
	}
	
}

int dir;
int px;
int py;

bool gototitle=false;

int main(int argc, char *argv[])
{

	init();


	loop<IntroLoop>();

titletag:
	gototitle=false;

	playmusic(3);
	loop<TitleLoop>();

	if (quit)
		goto end;

	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}
	
	playmusic(3);
	loop<CutsceneLoop<0> >();
	
	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}
	
	playmusic(0);
	loop<LevelLoop<0> >();
	
	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}
	
	playmusic(3);
	loop<CutsceneLoop<1> >();
	
	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}
	
	playmusic(1);
	loop<LevelLoop<1> >();
	
	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}
	
	playmusic(3);
	loop<CutsceneLoop<2> >();
	
	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}
	
	playmusic(2);
	loop<LevelLoop<2> >();
	
	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}
	
	playmusic(3);
	loop<CutsceneLoop<3> >();
	
	goto menuskip;



menuskip:
	quit=false;
	finishedtitle=false;
	TitleLoop::begin=false;
	goto titletag;

end:
	quit=false;
	return 0;

}
END_OF_MAIN()
